var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
  else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { MapToComponentField, MapToComponentMethod } from 'vega-slimmer/core';
import { SubStateObserverSlimmer } from '../slimmers/sub-state/sub-state-observer-slimmer';
/**
 * Controller for the form field states
 */
export class FormFieldStateControllerSlimmer extends SubStateObserverSlimmer {
  // eslint-disable-next-line jsdoc/require-jsdoc
  constructor() {
    super({
      parent: 'vega-form',
      subStates: [
        {
          subStateName: 'disableBlurValidation',
          parentStateName: 'disableBlurValidation',
          // eslint-disable-next-line jsdoc/require-jsdoc
          callback: (disableBlurValidation) => {
            var _a;
            (_a = this.validator) === null || _a === void 0 ? void 0 : _a.updateDisableBlurValidation(disableBlurValidation);
          },
        },
      ],
    });
  }
  /**
   * Component lifecycle - componentWillLoad
   */
  componentWillLoad() {
    super.componentWillLoad();
  }
}
__decorate([
  MapToComponentField()
], FormFieldStateControllerSlimmer.prototype, "host", void 0);
__decorate([
  MapToComponentField()
], FormFieldStateControllerSlimmer.prototype, "validator", void 0);
__decorate([
  MapToComponentMethod('setInjectFormFieldHelper')
], FormFieldStateControllerSlimmer.prototype, "componentWillLoad", null);
